python异常处理

发布时间:2019-07-4 15:13--阅读:320--评论:0条

1、什么是异常?

异常即是一个事件,该事件会在程序执行过程中发生,影响程序的正常执行。一般情况下,在Python无法正常处理程序时就会发生一个异常,异常是Python对象,表示一个错误。当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。

1

2

3

4

try:

    pass

except Exception,ex:

    pass

需求:将用户输入的两个数字相加

while True:
    num1 = raw_input('num1:')
    num2 = raw_input('num2:')
    try:
        num1 = int(num1)
        num2 = int(num2)
        result = num1 + num2
    except Exception, e:
        print '出现异常,信息如下:'
        print e

2、异常种类

python中的异常种类非常多,每个异常专门用于处理某一项异常!!!

AttributeError 试图访问一个对象没有的树形,比如foo.x,但是foo没有属性x
IOError 输入/输出异常;基本上是无法打开文件
ImportError 无法引入模块或包;基本上是路径问题或名称错误
IndentationError 语法错误(的子类) ;代码没有正确对齐
IndexError 下标索引超出序列边界,比如当x只有三个元素,却试图访问x[5]
KeyError 试图访问字典里不存在的键
KeyboardInterrupt Ctrl+C被按下
NameError 使用一个还未被赋予对象的变量
SyntaxError Python代码非法,代码不能编译(个人认为这是语法错误,写错了)
TypeError 传入对象类型与要求的不符合
UnboundLocalError 试图访问一个还未被设置的局部变量,基本上是由于另有一个同名的全局变量,
导致你以为正在访问它
ValueError 传入一个调用者不期望的值,即使值的类型是正确的
ArithmeticError
AssertionError
AttributeError
BaseException
BufferError
BytesWarning
DeprecationWarning
EnvironmentError
EOFError
Exception
FloatingPointError
FutureWarning
GeneratorExit
ImportError
ImportWarning
IndentationError
IndexError
IOError
KeyboardInterrupt
KeyError
LookupError
MemoryError
NameError
NotImplementedError
OSError
OverflowError
PendingDeprecationWarning
ReferenceError
RuntimeError
RuntimeWarning
StandardError
StopIteration
SyntaxError
SyntaxWarning
SystemError
SystemExit
TabError
TypeError
UnboundLocalError
UnicodeDecodeError
UnicodeEncodeError
UnicodeError
UnicodeTranslateError
UnicodeWarning
UserWarning
ValueError
Warning
ZeroDivisionError

对于特殊处理或提醒的异常需要先定义,最后定义Exception来确保程序正常运行。

1

2

3

4

5

6

7

8

9

s1 = 'hello'

try:

    int(s1)

except KeyError,e:

    print '键错误'

except IndexError,e:

    print '索引错误'

except Exception, e:

    print '错误'

3、异常其他结构

捕捉异常:

try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。 
如果你不想在异常发生时结束你的程序,只需在try里捕获它。 
语法: 
    try:
        <语句>                #运行别的代码
    except <名字>:
        <语句>                #如果在try部份引发了'name'异常
    except <名字>,<数据>:
        <语句>                #如果引发了'name'异常,获得附加的数据
    else:
        <语句>                #如果没有异常发生 

try的工作原理

当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可
以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

1. 如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的
except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异
常)。
2. 如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的
try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。
3. 如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的
话),然后控制流通过整个try语句。

打开一个文件,在该文件中的写入内容,且并未发生异常:
    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    else:
        print "内容写入文件成功"
        fh.close()

结果:
    # python test.py 
        内容写入文件成功
    # cat testfile       # 查看写入的内容
        这是一个测试文件,用于测试异常!! 

例
打开一个文件,在该文件中的内容写入内容,但文件没有写入权限,发生了异常:
    try:
        fh = open("testfile", "w")    
        fh.write("这是一个测试文件,用于测试异常!!")
    except IOError:
        print "Error: 没有找到文件或读取文件失败"
    else:
        print "内容写入文件成功"
        fh.close() 

在执行代码前为了测试方便,先去掉 testfile 文件的写权限
再执行以上代码:
    $ python test.py                                #注意这里用的是普通用户
    Error: 没有找到文件或读取文件失败

使用except不带任何异常类型

你可以不带任何异常类型使用except,如下实例:

     try:
        正常的操作
        ......................
     except:
        发生异常,执行这块代码
        ......................
     else:
        如果没有异常执行这块代码  

以上方式try-except语句捕获所有发生的异常。但这不是一个很好的方式,我们不能通过该程序
识别出具体的异常信息。因为它捕获所有的异常。

使用except带多种异常类型

也可以使用相同的except语句来处理多个异常信息:

    try:
        正常的操作
        ................
    except(Exception1[, Exception2[,...ExceptionN]]]):
       发生以上多个异常中的一个,执行这块代码
       ......................
    else:
        如果没有异常执行这块代码

try-finally 语句

try-finally 语句无论是否发生异常都将执行最后的代码。

    try:
        <语句>
    finally:
        <语句>    #退出try时总会执行

例1:

    try:
        fh = open("testfile", "w")
        fh.write("这是一个测试文件,用于测试异常!!")
    finally:
        print "Error: 没有找到文件或读取文件失败"

1

2

3

4

5

6

7

8

9

10

11

try:

    # 主代码块

    pass

except KeyError,e:

    # 异常时,执行该块

    pass

else:

    # 主代码块执行完,执行该块

    pass

finally:

    # 无论异常与否,最终执行该块

    pass

4.异常的参数:

一个异常可以带上参数,可作为输出的异常信息参数。
你可以通过except语句来捕获异常的参数,如下所示:

     try:
        正常的操作
        ......................
     except ExceptionType, Argument:
        你可以在这输出 Argument 的值... 

变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个
值。
元组通常包含错误字符串,错误数字,错误位置。


以下为单个异常的实例:

    #!/usr/bin/python
    def temp_convert(var):
        try:
            return int(var)
        except ValueError, Argument:
            print "参数没  有包含数字\n", Argument

    # 调用函数
    temp_convert("xyz")

以上程序执行结果如下:
    $ python test.py 
        参数没有包含数字
        invalid literal for int() with base 10: 'xyz'

5.触发异常

可以使用raise语句自己触发异常
raise语法格式:

raise [Exception [, args [, traceback]]]

语句中Exception是异常的类型(例如,NameError)参数是一个异常参数值。该参数是可
选的,如果不提供,异常的参数是"None"。
最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。


一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的
类,这是一个类的实例的参数。
定义一个异常:

def functionName( level ):
    if level < 1:
        raise Exception("Invalid level!", level)
        # 触发异常后,后面的代码就不会再执行

注意:为了能够捕获异常,"except"语句必须有用相同的异常来抛出类对象或者字符串。
例如我们捕获以上异常,"except"语句如下:

    try:
        正常逻辑
    except "Invalid level!":
        触发自定义异常    
    else:
        其余代码

    #!/usr/bin/python
    def mye( level ):
        if level < 1:
            raise Exception("Invalid level!", level)
            # 触发异常后,后面的代码就不会再执行
    try:
        mye(0)                # 触发异常
    except "Invalid level!":
        print 1
    else:
        print 2

输出结果:
    $ python test.py 
    Traceback (most recent call last):
      File "test.py", line 11, in <module>
        mye(0)
      File "test.py", line 7, in mye
        raise Exception("Invalid level!", level)
    Exception: ('Invalid level!', 0)

6.用户自定义异常

1

2

3

4

5

6

7

 

class WupeiqiException(Exception):

    def __init__(self, msg):

        self.message = msg

    def __str__(self):

        return self.message

try:

    raise WupeiqiException('我的异常')

except WupeiqiException,e:

    print e

通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自
Exception类,通过直接或间接的方式。
以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在
异常触发时输出更多的信息。
在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror
类的实例。

    class Networkerror(RuntimeError):
        def __init__(self, arg):
            self.args = arg
    在你定义以上类后,你可以触发该异常,如下所示:
    try:
        raise Networkerror("Bad hostname")
    except Networkerror,e:
        print e.args

7.万能异常

在python的异常中,有一个万能异常:Exception,它可以捕获任意异常。
例:

    #cat  aa.py
    s1 = 'hello'
    try:
        int(s1)
    except Exception,e:
        print e

执行结果:  
    #python aa.py 
    invalid literal for int() with base 10: 'hello'

8.assert断言

1

2

3

# assert 条件

assert 1 == 1

assert 1 == 2

使用assert断言是学习python一个非常好的习惯,assert断言句语格式及用法很简单。在没完善一个程序之前,我们不知道程序在哪里会出错,与其让它在运行最崩溃,不如在出现错误条件时就崩溃,这时候就需要assert断言的帮助。

assert断言的作用

assert断言是声明其布尔值必须为真的判定,如果发生异常就说明表达示为假。可以理解assert断言语句为raise-if-not,用来测试表示式,其返回值为假,就会触发异常。
assert断言语句的语法格式
assert expression

一些assert用法的语句供参考:

assert 1==1
assert 2+2==2*2
assert len(['my boy',12])<10
assert range(4)==[0,1,2,3]

如何为assert断言语句添加异常参数

assert的异常参数,其实就是在断言表达式后添加字符串信息,用来解释断言并更好的知道是哪里出了问题。格式如下:

assert expression [, arguments]

何时使用断言

Python的assert是用来检查一个条件,如果它为真,就不做任何事。如果它为假,则会抛出AssertError并且包含错误信息。例如:

py> x = 23
py> assert x > 0, "x is not zero or negative"
py> assert x%2 == 0, "x is not an even number"

Traceback (most recent call last):
File "", line 1, in ....
AssertionError: x is not an even number

很多人用assert作为一个很快和容易的方法来在参数错误的时候抛出异常。但这样做是错的,非常错误,有两个原因。首先AssertError不是在测试参数时应该抛出的错误。你不应该像这样写代码:

if
not isinstance(x, int):
raise AssertionError("not an int")

你应该抛出TypeError的错误,assert会抛出错误的异常。

但是,更危险的是,有一个关于assert的困扰:它可以被编译好然后从来不执行,如果你用 –O 或 –oo 选项运行Python,结果不保证assert表达式会运行到。当适当的使用assert时,这是未来,但是当assert不恰当的使用时,它会让代码用-O执行时出错。

那什么时候应该使用assert?没有特定的规则,断言应该用于:

    防御型的编程
    运行时检查程序逻辑
    检查约定
    程序常量
    检查文档

微信公众号ID:feiutech

评论列表

共0条评论

我要评论

用户名:
邮箱: